program bubble
  use sep
  use FT
  use util_axisIO

  implicit none


  integer :: naxis,n1,n2,i,j
  real :: threshold
  type(myaxis)  axis1, axis2, axis3
  ! <in.H bubble > out.H pad=pad_times
  ! pad_times means to pad as n times as input length 0 after input data BEFORE inverse.
  !           That will affect the negtive time casued the Periodicity



 

  real, dimension(:,:), allocatable :: d,output
  double complex, dimension(:,:), allocatable :: d_c
  integer :: pad_times,new_n1,max_pad_times,flt_len_b

  double precision:: d_scale,arg,m
  
   character(len=256) :: csz_threshold,csz_pad,csz_flt_len_b,csz_spectrum_1,csz_spectrum_2,csz_input,csz_origin

   character(len=256) :: spectrum_1,spectrum_2,input

  integer :: origin,freq_dom_shift

  csz_threshold = "th"
  csz_pad="pad"
  csz_flt_len_b="filtb_length"
  csz_spectrum_1="spectrum_1"
  csz_spectrum_2="spectrum_2"
  csz_input="input"
  csz_origin="origin"

   !Params
  call sep_init()


  call from_param (csz_threshold, threshold, 0.)
  call from_param (csz_pad, pad_times, 0)
  call from_param (csz_flt_len_b, flt_len_b, 0)
  call from_param (csz_spectrum_1, spectrum_1, 'NULL')
  call from_param (csz_spectrum_2, spectrum_2, 'NULL')
  call from_param (csz_input, input, 'NULL')
  call from_param (csz_origin, origin, 1)

  if (origin.ne.1 .and. origin.ne.2) then
    call erexit('origin.ne.1 .and. origin.ne.2')
  end if

  call hinaxis(axis1,1)
  call hinaxis(axis2,2)
  call hinaxis(axis3,3)
!   n2=n2*axis3%n

  axis1%o=0.0


  n1 = axis1%n; n2 = axis2%n
  if (axis3%n .gt. 1) then
    n2=n2*axis3%n
  end if

  write(0,*) "Usage: <in.H bubble > out.H pad=pad_times input=input_after_padding origin=[(1-time ) 2-freqency]"
  ! pad_times means to pad as n times as input length 0 after input data BEFORE inverse.
  !           That will affect the negtive time casued the Periodicity

  max_pad_times=10
  if (pad_times.gt.max_pad_times) then
    pad_times=max_pad_times
    write(0,*) 'warning pad_times exceed max_pad_times, and will be set to',pad_times
  end if
  if (pad_times.gt.1) then
    new_n1=n1*pad_times
  else
    new_n1=n1
  end if
  axis1%n=new_n1

  call houtaxis(axis1,1)

  if (spectrum_1.ne.'NULL') then
    call houtaxis(axis1,1,spectrum_1)
    call houtaxis(axis2,2,spectrum_1)
    call houtaxis(axis3,3,spectrum_1)
  end if

  if (spectrum_2.ne.'NULL') then
    call houtaxis(axis1,1,spectrum_2)
    call houtaxis(axis2,2,spectrum_2)
    call houtaxis(axis3,3,spectrum_2)
  end if

  if (input.ne.'NULL') then
    call houtaxis(axis1,1,input)
    call houtaxis(axis2,2,input)
    call houtaxis(axis3,3,input)
  end if

  write (0, * ) 'threshold',threshold
  write (0,*) 'new_n1',new_n1


  !n12 = n1*n2

  if (n1.le.1 .and. n2.le.1) then
    write(0,*) "n1 and n2 <= 0"
    stop
  end if

  allocate (d(n1,n2))
  allocate (d_c(new_n1,n2))
  allocate (output(new_n1,n2))

  d_c=0
  d=0
  output=0
 

  call sep_read(d)

  !
  !flip
  if (origin.eq.1) then
    if (flt_len_b.gt.1) then
      d_c(new_n1-flt_len_b+2:new_n1,:)=d(1:flt_len_b-1,:)
      d_c(1:n1-flt_len_b+1,:)=d(flt_len_b:n1,:)
    else
      d_c(1:n1,:)=d(:,:)
    end if
  else if (origin.eq.2) then
    write(0,*) 'Info: origin==2, ignore filtb_length'
    freq_dom_shift=(n1-1)/2
    if (freq_dom_shift.ge.1) then
      d_c(new_n1-freq_dom_shift+1:new_n1,:)=d(n1-freq_dom_shift+1:n1,:)
      d_c(1:n1-freq_dom_shift,:)=d(1:n1-freq_dom_shift,:)
    end if
  else
    call erexit('origin is not 1 or 2')
  end if

  if (input.ne.'NULL') call sep_write(real(real(d_c)),input)
  !n1=new_n1
  d_scale=1./new_n1
  write(0,*) new_n1,n2
  do i=1,n2
    
    call D_FT1D(d_c(:,i),new_n1,1,1.0D+00)
    if (spectrum_1.ne.'NULL') call sep_write(real(real(d_c(:,i))),spectrum_1)
    do j=1,new_n1
      if (abs(d_c(j,i)).lt.threshold) then
!         d_c(j,i)=1./threshold
        write(0,*) 'aaaaaaa'
      end if
        arg=atan2(imag(d_c(j,i)),real(d_c(j,i)))
        m=sqrt(abs(d_c(j,i)*d_c(j,i))+(threshold/2)*(threshold/2))  ! sqrt( m^2 + (threshold/2)^2 )
        d_c(j,i)=1.0D+00/(m*exp(cmplx(0,1)*arg))

!         d_c(j,i)=1.0D+00/d_c(j,i)

!       else
!          write(0,*) 'b------',d_c(j,i),abs(d_c(j,i))
!         d_c(j,i)=1.0D+00/d_c(j,i)
!          write(0,*) 'bbbbbbb',d_c(j,i),abs(d_c(j,i))
!       end if
!         write(0,*) m
    end do
    if (spectrum_2.ne.'NULL') call sep_write(real(abs(d_c(:,i))),spectrum_2)
    call D_FT1D(d_c(:,i),new_n1,-1,d_scale)
  end do
  !end if

  output=real(d_c)
  !flip
!   if (flt_len_b.gt.1) then
!     output(n1-flt_len_b+2:new_n1,:)=real(d_c(1:flt_len_b-1,:))
!     output(d_c(1:new_n1-flt_len_b+1,:)=real(flt_len_b+1:new_n1,:))
!   else
!     d_c(:,:)=d(:,:)
!   end if

  call sep_write(output)
  deallocate(d,d_c,output)

  call sep_close()
end program
