module FT
  ! Slow FT 1-D

!d_scale=1./t_n

!    call D_FT1D(C(1:t_n),t_n,-1,d_scale)
  use base_slofft_mod
 



contains


subroutine D_FT1D(C,T,nt,isign,scale,oit)
    implicit none
    double complex ::C(:)
    double complex ::T(:)
    double PRECISION, allocatable ::w(:)
    integer ::isign,nt,iw,it
    double PRECISION::scale
    double PRECISION ::ow,dw,pi
    integer,optional :: oit

    !write(0,*) "nt",nt

    allocate(w(nt))
    T=0.
    w=0.

    pi = 2.*ACOS(0.0)
    dw = 2.*pi/(nt)
    ow = 0.
    do iw = 1, nt
       w(iw) = ow  + (iw - 1) * dw
       !write(0,*)  w(iw)
    end do


    if (present(oit)) then
     do it=1,nt
         do iw=1,nt
             T(it)=T(it)+C(iw)*exp(cmplx(0,isign*w(iw)*(it-1+oit)))
         end do
     end do
    else
     do it=1,nt
         do iw=1,nt
             T(it)=T(it)+C(iw)*exp(cmplx(0,isign*w(iw)*(it-1)))
         end do
     end do
    end if

    !write(0,*)  real(T)
    !write(0,*) 'aaaaaaaaaaaaaaa'

    T=T*scale



    deallocate(w)
end subroutine



! subroutine FT1D(C,T,nt,isign,scale,oit)
!     implicit none
!     complex ::C(:)
!     complex ::T(:)
!     double PRECISION, allocatable ::w(:)
!     integer ::isign,nt,iw,it
!     double PRECISION::scale
!     double PRECISION ::ow,dw,pi
!     integer,optional :: oit
! 
!     !write(0,*) "nt",nt
! 
!     allocate(w(nt))
!     T=0.
!     w=0.
! 
!     pi = 2.*ACOS(0.0)
!     dw = 2.*pi/(nt)
!     ow = 0.
!     do iw = 1, nt
!        w(iw) = ow  + (iw - 1) * dw
!        !write(0,*)  w(iw)
!     end do
! 
! 
!     if (present(oit)) then
!      do it=1,nt
!          do iw=1,nt
!              T(it)=T(it)+C(iw)*exp(cmplx(0,isign*w(iw)*(it-1+oit)))
!          end do
!      end do
!     else
!      do it=1,nt
!          do iw=1,nt
!              T(it)=T(it)+C(iw)*exp(cmplx(0,isign*w(iw)*(it-1)))
!          end do
!      end do
!     end if
! 
!     !write(0,*)  real(T)
! !     write(0,*) '-------------------'
! 
!     T=T*scale
! 
! 
! 
!     deallocate(w)
!   end subroutine

  subroutine FT1D(C,T,nt,isign,scale)
    implicit none
    complex,intent(in)  ::C(:)
    complex,intent(out) ::T(:)
    integer ::isign,nt
    double PRECISION::scale

!     write(0,*) 'fft_nt=',nt

    T=C
    if (isign.eq.1) then
        call FFTCC(T, nt)
        T = T * scale
    else if (isign .eq. -1) then
        T = conjg(T)
        call FFTCC(T, nt)
        T = conjg(T) * scale
    else
        write(0,*)"FFT1DT: inv error!!!"
        STOP
    end if
  end subroutine

!     subroutine FFT1DT(A, inv)
!       implicit none
!       complex  :: A(:)
!       integer  :: inv, n
!       n = size(A)
!       if (inv.eq.1) then
!           call FFTCC(A, n)
!           A = A / sqrt(float(n))
!       else if (inv .eq. -1) then
!           A = conjg(A)
!           call FFTCC(A, n)
!           A = conjg(A) / sqrt(float(n))
!       else
!           write(0,*)"FFT1DT: inv error!!!"
!           STOP
!       end if
!     end subroutine





end module FT