module hybrid
  ! Hybrid norm 

  implicit none

!   real, private :: threshold_

contains
!   subroutine hybrid_init(threshold)
!     real threshold
!     threshold_=threshold
!     write(0,*) 'In hybrid.f90: Set threshold=',threshold
!   end subroutine
! 
!   subroutine hybrid_d0(input,output)
!   complex :: input(:),output(:)
!   integer :: i
!   double complex :: term
!     do i=1,size(input)
!        term = sqrt(1+input(i)**2/(threshold_**2))
!        output(i)= threshold_**1 * (term -1) 
!     end do
!   end subroutine
! 
!   subroutine hybrid_d1(input,output)
!   complex :: input(:),output(:)
!   integer :: i
!   double complex :: term
! !     write(0,*) 'in hybrid.f90: size input=',size(input)
!     do i=1,size(input)
!        term = sqrt(1+input(i)**2/(threshold_**2))
!        output(i)= input(i)/(threshold_*term)
! !         write(0,*) output(i)
!     end do
!   end subroutine
! 
!   subroutine hybrid_d2(input,output)
!   complex :: input(:),output(:)
!   integer :: i
!   double complex :: term
!     do i=1,size(input)
!        term = sqrt(1+input(i)**2/(threshold_**2))
!        output(i)= 1./(term**3*threshold_)
! !        write(0,*) output(i)
!     end do
!   end subroutine


  subroutine hybrid_d0(input,output,threshold)
  complex :: input(:),output(:)
  integer :: i
  double complex :: term
  real    :: threshold
    do i=1,size(input)
       term = sqrt(1+input(i)**2/(threshold**2))
       output(i)= threshold * (term -1) 
    end do
  end subroutine

  subroutine hybrid_d1(input,output,threshold)
  complex :: input(:),output(:)
  integer :: i
  double complex :: term
  real    :: threshold
!     write(0,*) 'in hybrid.f90: size input=',size(input)
    do i=1,size(input)
       term = sqrt(1+input(i)**2/(threshold**2))
       output(i)= input(i)/(threshold*term)
!         write(0,*) output(i)
    end do
  end subroutine

  subroutine hybrid_d2(input,output,threshold)
  complex :: input(:),output(:)
  integer :: i
  double complex :: term
  real    :: threshold
    do i=1,size(input)
       term = sqrt(1+input(i)**2/(threshold**2))
       output(i)= 1./(term**3*threshold)
!        write(0,*) output(i)
    end do
  end subroutine


end module