function [r] = write_h(fn,d,t)
% write history file of seplib data. function r = write_h(fn,d,t), which d is data array. t is the text header of previous steps.
	dim=size(d);
	count=numel(d);
%  	size(dim)
%  	dim

	strdatapath=fileread('~/.datapath');
	datapath=regexp(strdatapath,'^datapath=(.*?)$','tokens', 'lineanchors');

	fid=fopen(fn,'wt');
	if (fid==-1)
		r=-1;
		return;
	end
	if regexp(fn,'/')
		name=regexp(fn,'.*/(.*?)$','tokens');
	else
		name=regexp(fn,'^(.*)$','tokens');
	end
	at_fn=strcat(datapath{1}{1},name{1}{1},'.matlab.@');
	r=write_at(at_fn,d);
	assert(count==r);
	if (nargin >2) 
		fprintf(fid,'%s\n\n',t)
	end
	fprintf(fid,'Matlab:   %s@%s   %s\n',getenv('USER'),getenv('HOST'),datestr(now,'ddd mmm dd HH:MM:SS yyyy'));
	fprintf(fid,'		sets next: in="%s"\n',at_fn);

	if (nargin <3)
		for i=1:size(dim,2)
			fprintf(fid,'		n%d=%d o%d=0 d%d=1\n',i,dim(i),i,i);
		end
	else
		for i=1:size(dim,2)
			fprintf(fid,'		n%d=%d\n',i,dim(i));
		end
	end

	fprintf(fid,'		data_format="xdr_float"\n\n');
	fclose(fid);