program Pefmp_weight
  use sep

  implicit none


  integer :: n1,n2,n3,n123,flength,gap
  integer :: weight_n1,weight_n2,weight_n3,weight_n123,if_weight



 

  real, dimension(:), allocatable :: d,pef,weight
  character(len=256) :: csz_flength,csz_weight_filename

  csz_flength="flength"
  write(0,*) "Pefmp_weight.x < data.H flength=100 weight=weight.H gap=12 > pef.H"


   !Params
  call sep_init()

  call from_param (csz_flength, flength)
  call from_param ('weight', csz_weight_filename)
  call from_param ('gap', gap,0)
  call from_history ('n1', n1)
  call from_history ('n2', n2,1)
  call from_history ('n3', n3,1)



  if (gap.lt.0) then
    gap=0
  end if
  if (gap.gt.flength) then
    gap=flength
  end if

  n123=n1*n2*n3


  call from_aux(csz_weight_filename,'n1',weight_n1)
  call from_aux(csz_weight_filename,'n2',weight_n2,1)
  call from_aux(csz_weight_filename,'n3',weight_n3,1)


    call assert(weight_n1.eq.n1,'weight_n1.eq.n1')
    call assert(weight_n2.eq.n2 .or. weight_n2.eq.n2*n3,'weight_n2.eq.n2 .or. weight_n2.eq.n2*n3')
    write(0,*) 'debug weight_n2,n2,n3',weight_n2,n2,n3





  weight_n123=weight_n1*weight_n2*weight_n3
  call assert(n123.eq.weight_n123,'n123.eq.weight_n123')

  write (0, *) 'n123',n123
  write (0, * ) 'flength',flength
  write (0, * ) 'weight_n123',weight_n123

  if (n123.le.1) then
    write(0,*) "n123.le.1, n123=",n123
    stop 
  end if

  if (flength.le.1) then
    write(0,*) "flength.le.1, flength=",flength
    stop 
  end if

  if (weight_n123.le.1) then
    write(0,*) "weight_n123.le.1, weight_n123=",weight_n123
    stop 
  end if

  call to_history('n1',flength)
  call to_history('n2',1)
  call to_history('n3',1)

  allocate (d(n123),pef(flength),weight(weight_n123))

  call sep_read(d)

  
  call sep_read(weight,csz_weight_filename)

  call burgc_weight(d,pef,weight,gap)

  call sep_write(pef)
  deallocate(d,pef,weight)

  call sep_close()
end program

subroutine burgc_weight(input,filter,weight,gap)
  implicit none
  real,intent(in):: input(:),weight(:)
  real,intent(out):: filter(:)
  integer ::lx,lc,i,j
  complex,allocatable::x(:),ep(:),em(:),c(:),a(:),s(:)
  complex::bot,top,epi
  integer,intent(in):: gap

  lx=size(input)
  lc=size(filter)

  write (0,*) 'lx=',lx,'lc=',lc
  allocate(x(lx),ep(lx),em(lx),c(lc),a(lc),s(lx))
  s=0.

  c=0.
  a=0.
  a(1)=1.
  x=input
  em=x
  ep=x
  do j=2,lc
    top=0.
    bot=0.
    do i=j,lx
!       write(0,*) top,bot,ep(i)
      bot=bot+( ep(i)*conjg(ep(i))+em(i-j+1)*conjg(em(i-j+1)) )*weight(i)
      top=top+( ep(i)*conjg(em(i-j+1))                        )*weight(i)
    end do
    if (j.le.gap) then
      c(j)=0.
    else
      c(j)=2*top/bot
    end if
    do i=j,lx
      epi=ep(i)
      ep(i)=ep(i)-c(j)*em(i-j+1)
      em(i-j+1)=em(i-j+1)-conjg(c(j))*epi
    end do
    a(j)=0.
    do i=1,j
      s(i)=a(i)-c(j)*conjg(a(j-i+1))
    end do
    do i=1,j
      a(i)=s(i)
    end do
  end do

  filter=real(a)

  deallocate(x,ep,em,c,a,s)
end subroutine

SUBROUTINE assert(expression,string)
  implicit none
  logical 	:: expression
  character (len=*) :: string
  if (expression.eq..false.) then
    call erexit(string)
  end if
end SUBROUTINE